<?php
/* --------------------------------------------------------------
   dependent.inc.php 2020-09-10
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

$AutoUpdaterGroupId     = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'AutoUpdater');
$GambioStoreGroupId     = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'GambioStore');
$GambioStoreAjaxGroupId = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'GambioStoreAjax');

$gambioStoreAccessIdentifiers = [
    'GambioStore',
    'GambioStoreAjax'
];

if ($GambioStoreGroupId === false && $GambioStoreAjaxGroupId === false) {
    $this->addAdminAccessGroupItem($AutoUpdaterGroupId, 'CONTROLLER', $gambioStoreAccessIdentifiers);
}

$show_logsGroupID = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'show_logs.php');
$LoggingGroupID   = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'Logging');

if ($LoggingGroupID === false) {
    $this->addAdminAccessGroupItem($show_logsGroupID, 'CONTROLLER', 'Logging');
}

$gm_pdf_orderGroupID = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'gm_pdf_order.php');
$OrderAdminGroupID   = $this->getAdminAccessGroupIdByIdentifier('AJAX_HANDLER', 'OrderAdmin');

if ($OrderAdminGroupID === false) {
    $this->addAdminAccessGroupItem($gm_pdf_orderGroupID, 'AJAX_HANDLER', 'OrderAdmin');
}

$coupon_adminGroupID                 = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'coupon_admin.php');
$GiftSystemModuleCenterModuleGroupID =
    $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'GiftSystemModuleCenterModule');

if ($GiftSystemModuleCenterModuleGroupID === false) {
    $this->addAdminAccessGroupItem($coupon_adminGroupID, 'CONTROLLER', 'GiftSystemModuleCenterModule');
}

$AdminAccessGroupName = [
    1 => 'Scheduled tasks',
    2 => 'Zeitgesteuerte Aufgaben'
];

$AdminAccessGroupDescription = [
    1 => 'Allows the use of the scheduled tasks.',
    2 => 'Erlaubt die Nutzung der zeitgesteuerten Aufgaben.'
];
foreach ($AdminAccessGroupName as $lang => $name) {
    $cronJobgroupExists = $this->getAdminAccessGroupIdByName($name, $lang);
}

if ($cronJobgroupExists === false) {
    $cronJobgroupExists = $this->addAdminAccessGroup($AdminAccessGroupName, $AdminAccessGroupDescription, 1, 27);
}

$cronJobGroupId = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'CronjobsOverview');
if ($cronJobGroupId === false) {
    $this->addAdminAccessGroupItem($cronJobgroupExists, 'CONTROLLER', 'CronjobsOverview');
}

$AdminAccessGroupName = [
    1 => 'User friendly error pages',
    2 => 'Eigene Fehlerseiten'
];

$AdminAccessGroupDescription = [
    1 => 'Allows the use of the user friendly error pages.',
    2 => 'Erlaubt die Nutzung der eigenen Fehlerseiten.'
];
foreach ($AdminAccessGroupName as $lang => $name) {
    $errorGroupIdExists = $this->getAdminAccessGroupIdByName($name, $lang);
}

if ($errorGroupIdExists === false) {
    $errorGroupIdExists = $this->addAdminAccessGroup($AdminAccessGroupName, $AdminAccessGroupDescription, 1, 19);
}

$errorGroupId = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'AdminErrorPage');
if ($errorGroupId === false) {
    $this->addAdminAccessGroupItem($errorGroupIdExists, 'CONTROLLER', 'AdminErrorPage');
}

$t_success = isset($t_success) ? $t_success : true;

// in the 4.1.1.0 update value columns
// of gx_configuration were set to text
// while in the installer they're set to medium text

$query     = 'ALTER TABLE `gx_configurations` CHANGE `default` `default` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;';
$t_success &= $this->query($query, true);

$query     = 'ALTER TABLE `gx_configurations` CHANGE `value` `value` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;';
$t_success &= $this->query($query, true);